#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>
#include "rk4fix.h"

double A = 0.05, B = 1.0, F = 7.5;

vec6 duffin(double t, double r[6])
{ 
  vec6 ret;

  ret.f[0] = r[3];
  ret.f[3] = -A*r[3] - B*pow(r[0],3) + F*cos(t);
  return ret;
}

int 
main(int argc, char **argv)
{
  double r[6] = {0};
  double t = 0, h;
 
  if (argc < 3) {
    printf("%s F h\n", argv[0]);
    exit(0);
  }
  F = atof(argv[1]);
  h = atof(argv[2]);

  while(1) {
    rk4fixv6(duffin, t, r ,h);
    t += h;
    printf("%f %f\n", t, r[0]);
    fflush(stdout); 
 }

  return 0;
}
