#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>
#include "rk4fix.h"

#define  Tmax   10
#define  G      9.8
#define  TH0    60.0
#define  V0     10
#define  IVAL   10000

double b2;

vec6 mov(double t, double r[6])
{
  double v;
  vec6 ret;

  v = hypot(r[3],r[4]);
  ret.f[0] = r[3];
  ret.f[1] = r[4];
  ret.f[2] = 0;
  ret.f[3] = -b2*v*r[3];
  ret.f[4] = -G - b2*v*r[4];
  ret.f[5] = 0;

  return ret;
}

int main(int argc, char **argv)
{
  double r[6] = {0,0,0,0,0,0};
  double y, v, t = 0, h;
  FILE *GPLT;

  if (argc < 3) {
    printf("Usage: %s b2 h\n", argv[0]);
    exit(0);
  }
  b2 = atof(argv[1]);
  h = atof(argv[2]);
  r[3]=V0*cos(TH0/180*M_PI);
  r[4]=V0*sin(TH0/180*M_PI);

  GPLT = popen("gnuplot","w");
  fprintf(GPLT,"set xrange [0:4]\n");
  fprintf(GPLT,"set yrange [0:3]\n");
  while (t < Tmax){
    rk4fixv6(mov, t, r, h);
    t += h;
    fprintf(GPLT, "plot '-' pt 7 ps 3\n");
    fprintf(GPLT, "%f %f\ne\n", r[0], r[1]);
    fflush(GPLT);
    if (r[1] < 0) break;
    usleep(IVAL);
  }
  pclose(GPLT);

  return 0;
}
